<?php declare(strict_types=1);

namespace App\Controller;

use App\Entity\FoodOrder;
use App\Form\FoodOrderType;
use App\Repository\FoodOrderRepository;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

final class Start extends AbstractController
{
    #[Route('/')]
    public function index(
        FoodOrderRepository $foodOrderRepository,
        EntityManagerInterface $em,
        Request $request,
    ): Response {
        $openOrders = $foodOrderRepository->findOpen();
        $order = new FoodOrder('');
        $form = $this->createForm(FoodOrderType::class, $order);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $em->persist($order);
            $em->flush();
            return $this->redirectToRoute(
                'app_food_order_index',
                [],
                Response::HTTP_SEE_OTHER,
            );
        }

        return $this->render(
            'start/index.html.twig',
            [
                'orders' => $openOrders,
                'form' => $form,
            ],
        );
    }
}
