<?php declare(strict_types=1);

namespace App\Entity;

use App\Repository\MenuItemAliasRepository;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\IdGenerator\UlidGenerator;
use Symfony\Bridge\Doctrine\Types\UlidType;
use Symfony\Component\Uid\Ulid;

#[ORM\Entity(repositoryClass: MenuItemAliasRepository::class)]
class MenuItemAlias
{
    public function __construct(
        #[ORM\Id]
        #[ORM\GeneratedValue(strategy: 'CUSTOM')]
        #[ORM\Column(type: UlidType::NAME, unique: true)]
        #[ORM\CustomIdGenerator(class: UlidGenerator::class)]
        public Ulid $id = new Ulid,
        #[ORM\ManyToOne(inversedBy: 'aliases')]
        #[ORM\JoinColumn(nullable: false)]
        public MenuItem|null $menuItem = null,
        #[ORM\Column(length: 255)]
        public string|null $name = null,
    ) {}

    public static function new(string $name): self
    {
        $new = new self;
        $new->name = $name;
        return $new;
    }
}
