<?php declare(strict_types=1);

namespace App\Entity;

use App\Repository\OrderItemRepository;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Bridge\Doctrine\IdGenerator\UlidGenerator;
use Symfony\Bridge\Doctrine\Types\UlidType;
use Symfony\Component\Uid\Ulid;

#[ORM\Entity(repositoryClass: OrderItemRepository::class)]
class OrderItem
{
    public function __construct(
        #[ORM\Id]
        #[ORM\GeneratedValue(strategy: 'CUSTOM')]
        #[ORM\Column(type: UlidType::NAME, unique: true)]
        #[ORM\CustomIdGenerator(class: UlidGenerator::class)]
        public Ulid $id = new Ulid,
        #[ORM\ManyToOne(inversedBy: 'orderItems')]
        #[ORM\JoinColumn(nullable: false)]
        public FoodOrder|null $foodOrder = null,
        #[ORM\ManyToOne]
        #[ORM\JoinColumn(nullable: false)]
        public MenuItem|null $menuItem = null,
    ) {}
}
