<?php declare(strict_types=1);

namespace App\Repository;

use App\Entity\FoodOrder;
use DateTime;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @extends ServiceEntityRepository<FoodOrder>
 *
 * @method FoodOrder|null find($id, $lockMode = null, $lockVersion = null)
 * @method FoodOrder|null findOneBy(array $criteria, array $orderBy = null)
 * @method FoodOrder[]    findAll()
 * @method FoodOrder[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class FoodOrderRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, FoodOrder::class);
    }

    /**
     * @return Collection<int, FoodOrder>
     */
    public function findOpen(int $limit = 10): Collection
    {
        $yesterday = new DateTime;
        $yesterday->modify('-1 day');
        $queryBuilder = $this->createQueryBuilder('e');
        $queryBuilder
            ->where('e.closedAt IS NULL')
            ->andWhere($queryBuilder->expr()->gte('e.startedAt', ':yesterday'))
            ->setParameter('yesterday', $yesterday);
        return new ArrayCollection($queryBuilder->getQuery()->getResult());
    }
}
